@echo off

del /F /Q *.o *.elf *.hex 2>nul

if "%1"=="clean" (
    echo OK
    exit /b 0
) 

set GCC_FLAGS=-mcpu=cortex-m3 -Wall -ffunction-sections -mthumb -Iinclude -I. -c

call set OBJS=startup.o

%GCC_PREFIX%gcc -mcpu=cortex-m3 -mthumb -I . -c -o startup.o startup.s

for %%f in (*.c) do (
    echo Compiling %%f...
    %GCC_PREFIX%gcc -mcpu=cortex-m3 -DUSE_MDR1986VE9x -O2 -mthumb --function-sections -I. -I%CANOPEN%\include -c -o %%~nf.o %%f
    call set OBJS=%%OBJS%% %%~nf.o
)

echo Linking %OBJS%...
%GCC_PREFIX%gcc -mthumb -mcpu=cortex-m3 -Wl,--gc-sections -u _vectors -nostartfiles -T MDR32F9Qx.ld -o fxrtos_demo.elf %OBJS% libcanopen.a libcanopendrv.a libfxrtos.a
%GCC_PREFIX%objcopy --target ihex fxrtos_demo.elf fxrtos_demo.hex
