#include "io_control.h"

void button_init(void)
{
	RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTE, ENABLE);
	PORT_InitTypeDef PORT_InitStructure;
    
	PORT_InitStructure.PORT_OE = PORT_OE_IN;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_SLOW;
	PORT_InitStructure.PORT_Pin = (PORT_Pin_3);

	PORT_Init(MDR_PORTE, &PORT_InitStructure);
}

uint8_t button_state(void)
{
	return PORT_ReadInputDataBit(MDR_PORTE, PORT_Pin_3);
}

void led_init(void)
{
    RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTB, ENABLE);
	PORT_InitTypeDef PORT_InitStructure;

	PORT_InitStructure.PORT_OE = PORT_OE_OUT;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	PORT_InitStructure.PORT_Pin = PORT_Pin_0 | PORT_Pin_1 | PORT_Pin_2;

	PORT_Init(MDR_PORTB, &PORT_InitStructure);
}

void led_write(bool on_off)
{
	PORT_WriteBit(MDR_PORTB, PORT_Pin_0, on_off ? Bit_SET : Bit_RESET);
}
