#ifndef __TIMERSCFG_PORTS_FXRTOS_H__
#define __TIMERSCFG_PORTS_FXRTOS_H__


#include "applicfg.h"

#define TIMEVAL            UNS32
#define TIMEVAL_MAX        (0x0000FFFFUL)

//
// @brief Converting time to ticks
//
extern TIMEVAL MS_TO_TIMEVAL(TIMEVAL ms);
extern TIMEVAL US_TO_TIMEVAL(TIMEVAL us);

//
// @brief Return the elapsed time to tell the Stack how much time is spent since last call.
// @param   void
// @return  TIMEVAL the elapsed time
//
extern TIMEVAL getElapsedTime(void);

//
// @brief Set the timer for the next alarm.
// @param   TIMEVAL
// @return  void
//
extern void setTimer(TIMEVAL value);

//
// @brief Initializes the timer
// @param   timer clock
// @return  void
//
extern void initTimer(uint32_t hclk, uint32_t* stack, uint32_t stack_size, uint32_t prio);


#endif
