@echo off
echo Cleaning up...

del /F /Q *.o sdmmc sdmmc.so
if "%1"=="clean" (
    echo OK
    exit /b 0
)

set PATH_UNDEF=
IF NOT DEFINED GCC_PREFIX (
    echo "Variable GCC_PREFIX is not defined"
)
IF NOT DEFINED FXRTOS_SDK (
    echo "Variable FXRTOS_SDK path is not defined"
    set PATH_UNDEF=1
)
IF DEFINED PATH_UNDEF (
    goto:end
)
IF DEFINED CPU (
    set CFLAGS=%CFLAGS% -mcpu=%CPU%
)

set GCC=%GCC_PREFIX%gcc

set TARGET_FLAGS=-I. -I%TARGET_CPU% ^
    -DSDMMC_TRIM_SDIO ^
    -DSDMMC_TRIM_MMC ^
    -DTRACE_LEVEL=0 ^
    -DCONFIG_HAVE_HSMCI ^
    -DCONFIG_HAVE_AIC5 ^
    -DCONFIG_HAVE_PMC_PLLADIV2 ^
    -DCONFIG_HAVE_PMC_PLLA_CHARGE_PUMP ^
    -DCONFIG_HAVE_PMC_UPLL_BIAS ^
    -DCONFIG_HAVE_SCKC ^
    -DCONFIG_HAVE_DMAC ^
    -DCONFIG_HAVE_DMAC_DATA_WIDTH_DWORD

set GCC=%GCC_PREFIX%gcc
set CFLAGS=-std=c99 -O0 -mno-unaligned-access -z max-page-size=0x1000 -I%FXRTOS_SDK%\include %TARGET_FLAGS% -DDEBUG
set SO_CFLAGS=-fPIC -Wl,-shared -Wl,-no-undefined
set LDFLAGS=-Xlinker --dynamic-linker=libfxrtos.so -nostartfiles -Xlinker --build-id=none
set LLIBS=-Xlinker -L%FXRTOS_SDK%\lib -Xlinker -lfxrtos 

set SO_LDSCR=%FXRTOS_SDK%\ld_scripts\libso-gnu.ld

echo Compiling driver...

%GCC% %CFLAGS% %SO_CFLAGS% -c -o sdmmc.o sdmmc.c
%GCC% %CFLAGS% %SO_CFLAGS% -c -o sdmmc_api.o sdmmc_api.c
%GCC% %CFLAGS% %SO_CFLAGS% -c -o system.o system.c
%GCC% %CFLAGS% %SO_CFLAGS% -c -o board.o %TARGET_CPU%/%TARGET_BOARD%.c
%GCC% %CFLAGS% %SO_CFLAGS% -c -o hsmcid.o %TARGET_CPU%/hsmcid.c
%GCC% %CFLAGS% %SO_CFLAGS% -c -o hsmci.o %TARGET_CPU%/hsmci.c
%GCC% %CFLAGS% %SO_CFLAGS% -c -o hsmci_dma.o %TARGET_CPU%/hsmci_dma.c

%GCC% %SO_CFLAGS% %LDFLAGS% -T %SO_LDSCR% %LLIBS% -o sdmmc.so sdmmc.o sdmmc_api.o system.o board.o hsmcid.o hsmci.o hsmci_dma.o %FXRTOS_SDK%\lib\libc.a

:end
echo Done.
