HTTP-server running on FX-RTOS nanokernel
========================================

Demo description
----------------

The demo contains simple web server application.
After demo starts it is available via network at address:

http://192.168.128.11

the address may be changed in main.c source file.
Web-page contains static text: "FX-RTOS network demo page."

Files listing
-------------

| File name       | Description
|-----------------|---------------------------------------------------------
| include         | include files for network stack
| core_cm3.h      | ARM Cortex M3 core description
| LPC17xx.h       | LPC17xx peripherals description
| led.c           | LED control functions
| system_LPC17xx.c| PLL/clocks functions
| system_LPC17xx.h| PLL/clocks interface
| build.bat       | build script
| FXRTOS.h        | FX-RTOS interface header
| fxrtos_demo.elf | application binary
| fxrtos_demo.hex | application image for download
| libenetdrv.a    | LPC17xx Ethernet driver
| libfxnet  .a    | TCP/IP stack
| libfxrtos.a     | FX-RTOS kernel
| lpc17xx_eth.h   | Ethernet driver interface
| LPC1768.ld      | linker script and memory layout
| main.c          | application
| startup.S       | vector table

Building
--------

Prerequisites: 
compiler and linker must be directly accessible (via PATH environment variable).

1. Set GCC_PREFIX variable for toolchain being used 
   i.e. set GCC_PREFIX=arm-none-eabi-
2. Run build.bat in demo folder

HEX-files containing downloadable image should appear.

Hardware setup
--------------

The demo uses Keil MCB1700 board with NXP LPC1768 MCU. Flash programming is
performed using In-System programming feature and UART connection.

1. Have the board connected via external UART adapter to PC (COM0 connector).
2. Make sure that ISP jumper is set.
3. Connect network cable to the PC or network switch.
4. Connect USB type B cable to PC. It is used as power source.

Note that UART adapter and network cable are not included in MCB1700 evaluation
kit.

Downloading to target
---------------------

Compiled images may be downloaded to the device by external tools 
such as Flash Magic for NXP devices. 
(See http://www.flashmagictool.com/)
