﻿HTTP-сервер использующий FX-RTOS nanokernel
==================================================

Описание демонстрационного приложения
-------------------------------------

Демонстрационное приложение содержит встроенный веб-сервер.
После запуска демонстрационного приложения устройство доступно через сеть по 
адресу:

http://192.168.128.11

адрес может быть изменен в файле main.c.
Веб-страница содержит статический текст: "FX-RTOS network demo page."

Список файлов
-------------

| Имя файла       | Описание
|-----------------|---------------------------------------------------------
| include         | заголовочные файлы для сетевого стека в libfxnet.a
| core_cm3.h      | описание ядра ARM Cortex M3
| LPC17xx.h       | описание периферии LPC17xx
| led.c           | функции для работы со светодиодами
| system_LPC17xx.c| реализация функций настройки частоты
| system_LPC17xx.h| интерфейс настройки частоты
| build.bat       | сценарий сборки
| FXRTOS.h        | заголовочный файл интерфейса FX-RTOS
| fxrtos_demo.elf | собранное приложение
| fxrtos_demo.hex | образ для загрузки в устройство
| libenetdrv.a    | драйвер сетевого интерфейса LPC17xx
| libfxnet.a      | библиотека содержащая стек TCP/IP
| libfxrtos.a     | ядро FX-RTOS
| lpc17xx_eth.h   | интерфейсный заголовочный файл библиотеки libenetdrv.a
| LPC1768.ld      | сценарий компоновщика
| main.c          | приложение
| startup.S       | таблица векторов и начальная инициализация

Сборка
------

Предварительные условия: 
компилятор и компоновщик должны быть доступны через переменную PATH.

1. Установить переменную окружения GCC_PREFIX для используемого компилятора. 
   Пример: set GCC_PREFIX=arm-none-eabi-
2. Выполнить build.bat

Результат: должен появиться загружаемый файл HEX в папке приложения.

Подготовка оборудования
-----------------------

Демо-приложение использует оценочную плату Keil MCB1700 с контроллером LPC1768.
Программирование флеш-памяти осуществляется через внешний адаптер UART.

1. Подключите плату через адаптер UART к инструментальному ПК (разъем COM0).
2. Убедитесь, что переключатель ISP на плате установлен.
3. Соедините плату сетевым кабелем с компьютером или сетевым коммутатором.
4. Подключите разъем USB-B к ПК. Этот разъем используется как источник питания.

Обратите внимание, что адаптер UART и сетевой кабель не входят в комплект 
MCB1700.

Загрузка в устройство
---------------------

Полученный hex-файл может быть загружены в устройство с использованием внешних 
инструментов для прошивки.
Например с помощью flash magic (http://www.flashmagictool.com/)
