.syntax unified
.cpu cortex-m3
.thumb

.extern main
.extern hal_svc_entry
.extern hal_swi_entry
.extern hal_tick_entry
.extern hal_intr_entry
.extern hal_trap_entry

.section .vectors, "ax"
.code 16
.align 0
.global _vectors

_vectors:
.word     0x10008000                  // Top of interrupts stack
.word     RESET_Handler               // Reset Handler
.word     system_stop              // NMI
.word     system_stop              // HardFault
.word     system_stop              // MPU Fault Handler
.word     system_stop              // Bus Fault Handler
.word     system_stop              // Usage Fault Handler
.word     0                           // Reserved
.word     0                           // Reserved
.word     0                           // Reserved
.word     0                           // Reserved
.word     system_stop               // SVCall Handler
.word     system_stop              // Debug Monitor Handler
.word     0                           // Reserved
.word     hal_swi_entry               // PendSV Handler
.word     hal_tick_entry              // SysTick Handler
.word     hal_intr_entry              // Watchdog Handler
.word     hal_intr_entry              // TIMER0 Handler
.word     hal_intr_entry              // TIMER1 Handler
.word     hal_intr_entry              // TIMER2 Handler
.word     hal_intr_entry              // TIMER3 Handler
.word     hal_intr_entry              // UART0 Handler
.word     hal_intr_entry              // UART1 Handler
.word     hal_intr_entry              // UART2 Handler
.word     hal_intr_entry              // UART3 Handler
.word     hal_intr_entry              // PWM1 Handler
.word     hal_intr_entry              // I2C0 Handler
.word     hal_intr_entry              // I2C1 Handler
.word     hal_intr_entry              // I2C2 Handler
.word     hal_intr_entry              // SPI Handler
.word     hal_intr_entry              // SSP0 Handler
.word     hal_intr_entry              // SSP1 Handler
.word     hal_intr_entry              // PLL0 Handler
.word     hal_intr_entry              // RTC Handler
.word     hal_intr_entry              // EXT Interupt 0 Handler
.word     hal_intr_entry              // EXT Interupt 1 Handler
.word     hal_intr_entry              // EXT Interupt 2 Handler
.word     hal_intr_entry              // EXT Interupt 3 Handler
.word     hal_intr_entry              // ADC Handler
.word     hal_intr_entry              // BOD Handler
.word     hal_intr_entry              // USB Handler
.word     hal_intr_entry              // CAN Handler
.word     hal_intr_entry              // General Purpose DMA Handler
.word     hal_intr_entry              // I2S Handler
.word     hal_intr_entry              // Ethernet Handler
.word     hal_intr_entry              // Repetitive Interrupt Timer Handler
.word     hal_intr_entry              // Motor Control PWM Handler
.word     hal_intr_entry              // Quadrature Encoder Handler
.word     hal_intr_entry              // PLL1 Handler

.section .text
.global RESET_Handler
.thumb_func
RESET_Handler:

copy_data_start:
  ldr   r0, =_etext
  ldr   r1, =_data
  ldr   r2, =_data_sz
  cmp   r2, $0
  beq   init_bss_start

copy_data:
  ldrb  r4, [r0]
  strb  r4, [r1]
  adds  r0, r0, $1
  adds  r1, r1, $1
  subs  r2, r2, $1
  bne   copy_data

init_bss_start:
  ldr   r0, =0
  ldr   r1, =_bss
  ldr   r2, =_bss_sz 
  cmp   r2, $0
  beq   image_init_done
        
init_bss:
  strb  r0, [r1]
  adds  r1, r1, $1
  subs  r2, r2, $1
  bne   init_bss
        
image_init_done:

  cpsid i
  isb
  b main                              // Jump to C entry.
