@echo off

del /F /Q *.o *.elf *.hex 2>nul

if "%1"=="clean" (
    echo OK
    exit /b 0
) 

call set OBJS=startup.o

%GCC_PREFIX%gcc -mcpu=cortex-m4 -mthumb -I . -c -o startup.o startup_stm32f411retx.s

for %%f in (*.c) do (
    echo Compiling %%f...
    %GCC_PREFIX%gcc -DSTM32F411xE -DUSE_FULL_LL_DRIVER -mcpu=cortex-m4 -Wall -O2 -mthumb --function-sections -nostartfiles -nostdlib -I. -c -o %%~nf.o %%f
    call set OBJS=%%OBJS%% %%~nf.o
)

echo Linking %OBJS%...
%GCC_PREFIX%gcc -mthumb -mcpu=cortex-m4 -Wl,--gc-sections -u _vectors -nostartfiles -T STM32F411RETX_FLASH.ld -o fxrtos_demo.elf %OBJS% libnandftl.a libfxrtos.a
%GCC_PREFIX%objcopy --target ihex fxrtos_demo.elf fxrtos_demo.hex
