
#include <stdio.h>
#include <FXRTOS.h>
#include <nand.h>
#include <map.h>

#include "fx_nand_hw.h"

#define TOTAL_BLOCKS	1024
#define COL_BIT_WIDTH	11	// log2(PAGE_SIZE)
#define PPB_BIT_WIDTH	6 	// log2(PAGES_IN_BLOCK)
#define	BUS_WIDTH		8

const struct dhara_nand samsung_k9f1g08u08b =
{
	.log2_page_size = COL_BIT_WIDTH,
	.log2_ppb = PPB_BIT_WIDTH,
	.num_blocks = TOTAL_BLOCKS,
};

static struct dhara_map map;

static uint8_t page_buf[2112];

static uint8_t test_buf[2048] ="";

void ftl_main(void* unused)
{
	dhara_error_t err = DHARA_E_NONE;
	nand_init();
    nand_status(Chip0_Select);

	dhara_map_init(&map, &samsung_k9f1g08u08b, page_buf, 10);
	
	/*
	dhara_map_clear(&map);
	*/
	
	int ret = dhara_map_resume(&map, &err);
	
	/*
	dhara_map_read(&map, 1, test_buf, &err);
	ret = dhara_map_write(&map, 3, test_buf, &err);
	dhara_map_sync(&map, &err);
    */
	
	/*
	memset(test_buf, 0, sizeof(test_buf));
    dhara_map_read(&map, 2, test_buf, &err);
	dhara_map_read(&map, 1, test_buf, &err);
	*/
	
	ret = dhara_map_read(&map, 3, test_buf, &err);
	
	/*
	ret = dhara_map_trim(&map, 1, &err);
    ret = dhara_map_trim(&map, 2, &err);
    ret = dhara_map_trim(&map, 3, &err);
    dhara_map_sync(&map, &err);
    */
	
	/*
	dhara_map_copy_sector(&map, 1, 10, &err);
	dhara_map_read(&map, 10, test_buf, &err);
    */

	printf("%d", ret);
	fx_thread_exit();
}
