@echo off

del /F /Q *nandftl*.* src\*.o src\*.obj 2>nul

if "%1"=="clean" (
    echo OK
    exit /b 0
) 

if not exist src (
	mkdir src

	copy %NANDFTL%\dhara\*.c src
	copy %NANDFTL%\dhara\*.h src
	copy %NANDFTL%\ecc\*.c src
	copy %NANDFTL%\ecc\*.h src
)

if "%1"=="srccopy" (
    echo OK
    exit /b 0
) 

set GCC_FLAGS= -mcpu=cortex-m4 -O2 -ffunction-sections -mthumb -I%FXRTOS% -Iinclude -c
call set OBJS=

for %%f in (src\*.c) do (
    echo Compiling %%f...
    %GCC_PREFIX%gcc %GCC_FLAGS% -o src\%%~nf.o %%f
    call set OBJS=%%OBJS%% %%~nf.o
)

cd src
echo Creating library...
%GCC_PREFIX%ar rcs ../libnandftl.a %OBJS%
copy nand.h ..
copy map.h ..
copy error.h ..
copy journal.h ..
copy hamming.h ..
cd ..

exit /b

