@echo off
echo Cleaning up...

if exist *.o del /F /Q *.o
if exist *.elf del /F /Q *.elf
if exist *.hex del /F /Q *.hex

if "%1"=="clean" (
	echo OK
	exit /b 0
)

echo Compiling...

for %%f in (*.c) do (
	echo %%f
	%GCC_PREFIX%gcc -DUSE_MDR1986VE9x -mcpu=cortex-m3 -mthumb -I. -c -o %%~nf.o %%f
)

for %%f in (*.S) do (
	echo %%f
	%GCC_PREFIX%gcc -mcpu=cortex-m3 -mthumb -I. -c -o %%~nf.o %%f
)

echo Linking...

%GCC_PREFIX%ld -u _vectors --Map=map.txt --gc-sections -nostartfiles -T MDR32F9Qx.ld -o fxrtos_demo_msc.elf msc.o blockdev.o main.o MDR32F9Qx_rst_clk.o system_MDR32F9Qx.o startup.o libfxrtos.a libusbdev.a libusbdevdrv.a
%GCC_PREFIX%ld -u _vectors --Map=map.txt --gc-sections -nostartfiles -T MDR32F9Qx.ld -o fxrtos_demo_hid.elf hid.o main.o MDR32F9Qx_rst_clk.o system_MDR32F9Qx.o startup.o libfxrtos.a libusbdev.a libusbdevdrv.a

%GCC_PREFIX%objcopy --target ihex fxrtos_demo_msc.elf fxrtos_demo_msc.hex
%GCC_PREFIX%objcopy --target ihex fxrtos_demo_hid.elf fxrtos_demo_hid.hex

echo Done.
