
//
// offset in hal_intr_regs_t struct
//
#define E2K_CTX_LSR     (0 * 8)
#define E2K_CTX_ILCR    (1 * 8)
#define E2K_CTX_CTRP1   (2 * 8)
#define E2K_CTX_CTRP2   (3 * 8)
#define E2K_CTX_CTRP3   (4 * 8)
#define E2K_COMMON_REGS_SIZE (5 * 8)

#define PSR_IE   (1UL << 1)
#define PSR_UIE  (1UL << 4)

.extern g_hal_intr_regs
.extern hal_intr_handler
.extern hw_cpu_idle

.global ttable_entry0;

.section .ttable_entry0, "ax",@progbits
.align 8
.type ttable_entry0,@function
ttable_entry0:
	setwd   wsz = 10, nfx = 0;
    setbn   rsz = 2, rbs = 8, rcur = 0x0

	rrd %ctpr1, %dr1
	rrd %ctpr2, %dr2
	rrd %ctpr3, %dr3
	rrd %ilcr,  %dr4
	rrd %lsr,   %dr5

	/* sizeof pt_regs */
	getsp -(E2K_COMMON_REGS_SIZE), %dr0

	std %dr1, [%dr0 + E2K_CTX_CTRP1]
	std %dr2, [%dr0 + E2K_CTX_CTRP2]
	std %dr3, [%dr0 + E2K_CTX_CTRP3]

	std %dr4, [%dr0 + E2K_CTX_ILCR]
	std %dr5, [%dr0 + E2K_CTX_LSR]

    std %dr0, [g_hal_intr_regs]

    disp %ctpr2, .TRAP
    rrd %psr, %dr0
    // Check if user control (nmie enabled) already set, dive into interrupt handler
    cmpandesb %dr0, PSR_UIE, %pred0
    ct %ctpr2 ? ~%pred0

     // Put cores with id > 0 to the infinite loop
    disp %ctpr1, .IDLE_CPU
    rrd %idr, %dr0
    shrd %dr0, 15, %dr1
    andd %dr1, 0x1F, %dr2
    cmpedb %dr2, 0, %pred0
    ct %ctpr1 ? ~%pred0

    // Set user control of interrupts
    ord %dr0, PSR_UIE | PSR_IE , %dr1
    rwd %dr1, %psr

    // call main
	disp    %ctpr1, main
	ct      %ctpr1

.TRAP:
    disp    %ctpr1, hal_intr_handler
    ct      %ctpr1

.IDLE_CPU:
    disp    %ctpr1, hw_cpu_idle
	ct      %ctpr1
.size  $ttable_entry0,.-$ttable_entry0
