OUTPUT_FORMAT("elf64-e2k", "elf64-e2k", "elf64-e2k")
OUTPUT_ARCH(elbrus-v4)
ENTRY(_start)

MEMORY {
	BOOT : ORIGIN = 0x23F0000, LENGTH = 0x10000
	RAM : ORIGIN =  0x2400000, LENGTH = 0x100000
}

_ram_base = ORIGIN(RAM);
_ram_size = LENGTH(RAM);

SECTIONS {
	.bootinfo : {
		_bootinfo_start = .;
		/* . = 0x1000000 - 0x10000; */
		/* 0x00FF0000 */
		KEEP(*(.x86_boot));
		. = _bootinfo_start + 0x10000;
		_bootinfo_end = .;
	} > BOOT

	.text : {
		_start = .;
		 _t_entry = .;
		/* Interrupt handler */
		KEEP(*(.ttable_entry0));
		. = _t_entry + 0x800;
		_t_entry_end = .;

		KEEP(*(.e2k_entry));
		KEEP(*(.cpu_idle));

		/* text */
		*(.text)
	} > RAM

    .data : {
        *(.data)
    } > RAM

    .bss : {
        *(.data)
    } > RAM
}
